<?php
	require_once('../../../wp-config.php'); 
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xmlns:v="urn:schemas-microsoft-com:vml">
  <head>
    <meta http-equiv="content-type" content="text/html; charset=utf-8"/>
    <title>Google Maps</title>
	<?php
		require_once('googleMapAPI_PMPro.php'); 		 
		$googlemaps_key = "ABQIAAAAppuSIeVGT9jmZdjNDOu9IRQNVut8Q049bqVJAF1T7nK0XKDaaxS4OXzLcd8Trw_F7hXgLfg0zN8AXQ";
		$googlemaps = new googleMapAPI_PMPro($googlemaps_key);
		$googlemaps->width = "100%";
		$googlemaps->height = "400px";		
		$id = -1;
		if (isset($_GET["gpxid"])) {
			$id = intval($_GET["gpxid"]);			          
		} else {
			if (isset($_GET["kmlid"])) {
				$id = intval($_GET["kmlid"]);
			} else {
				if (isset($_GET["mygooglemapid"])) {
					$id = intval($_GET["mygooglemapid"]);
				}				
			}
		}
		$manualzoom = 0;
		$minlat = 0;
		$maxlat = 0;
		$minlon = 0;
		$maxlon = 0;
		$interval = 1;
		$color = "blue";
		$linewidth = 5;
		$lineopacity = 50;
		$varstring = getvarstring($id);
		$vars = split(";",$varstring);
		$gpxview = "all";
		for ($i=0 ;$i<count($vars);$i++) {
			$varvalue=split("=",$vars[$i]);
			if (count($varvalue)==2) {
				switch ($varvalue[0]) {
					case "maptype":
						$googlemaps->setMapType($varvalue[1]);			
						break;
					case "gpxinterval":
						if (is_numeric($varvalue[1])) {
							$interval = intval($varvalue[1]);								
						}
						break;
					case "gpxcolor":
						$color = $varvalue[1];
						break;
					case "gpxlinewidth";
						if (is_numeric($varvalue[1])) {
							$linewidth = intval($varvalue[1]);								
						}
						break;
					case "gpxlineopacity":					
						if (is_numeric($varvalue[1])) {
							$lineopacity = intval($varvalue[1]);								
						}
						break;
					case "gpxview":
						$gpxview = $varvalue[1];					
						break;
					case "maxlat":					
						if (is_numeric($varvalue[1])) {
							$maxlat = doubleval($varvalue[1]);
							$manualzoom++;								
						}
						break;					
					case "maxlon":					
						if (is_numeric($varvalue[1])) {
							$maxlon = doubleval($varvalue[1]);
							$manualzoom++;								
						}
						break;		
					case "minlat":					
						if (is_numeric($varvalue[1])) {
							$minlat = doubleval($varvalue[1]);
							$manualzoom++;								
						}
						break;					
					case "minlon":					
						if (is_numeric($varvalue[1])) {
							$minlon = doubleval($varvalue[1]);
							$manualzoom++;								
						}
						break;								
				}
			}
		}
		print($googlemaps->getHeaderScript());
	?>
	</head>
	<body leftmargin="0" topmargin="0" marginwidth="0" marginheight="0" onunload="GUnload()">
	<?php
			
		if (isset($_GET["gpxid"])) {
			require_once('gpxParser.php');
			$file = getpathresolved($id);
			$gpxfile = new gpxParser();
			$gpxfile->parse($file);
			
			$gpxdata = $gpxfile->output;
					
			$maxwpt = $gpxdata["wpt_count"];
			$counter = 0;
				
			for ($counter=0; $counter<$maxwpt; $counter++) {
				$googlemaps->addMarker($gpxdata["wpt".$counter]["LAT"],$gpxdata["wpt".$counter]["LON"],"<b>".$gpxdata["wpt".$counter]["NAME"]."</b><br>".$gpxdata["wpt".$counter]["DESCRIPTION"]);	
			}
			if (($gpxview == "all") || ($gpxview == "rte")) {
				$rtemax = $gpxdata["rte_count"];
				for ($rtecount=0;$rtecount<$rtemax; $rtecount++) {
					$rteptmax=$gpxdata["rte".$rtecount]["rtept_count"];
					$pl = $googlemaps->addPolyline($color,$linewidth,$lineopacity);
					for ($rteptcount=0;$rteptcount<$rteptmax; $rteptcount+=$interval) {
						$pt = $gpxdata["rte".$rtecount]["rtept".$rteptcount];
						$googlemaps->addPolylinePoint($pl,$pt["LAT"],$pt["LON"]);
					}
					if ($rteptcount < $rteptmax - 1) {
						$rteptcount = $rteptmax - 1;
						$pt = $gpxdata["rte".$rtecount]["rtept".$rteptcount];
						$googlemaps->addPolylinePoint($pl,$pt["LAT"],$pt["LON"]);					
					}
				}
			}
			if (($gpxview == "all") || ($gpxview == "trk")) {
				$trkmax = $gpxdata["trk_count"];
				for ($trkcount=0;$trkcount<$trkmax; $trkcount++) {
					$trkptmax=$gpxdata["trk".$trkcount]["trkpt_count"];
					$pl = $googlemaps->addPolyline($color,$linewidth,$lineopacity);
					for ($trkptcount=0;$trkptcount<$trkptmax; $trkptcount+=$interval) {
						$pt = $gpxdata["trk".$trkcount]["trkpt".$trkptcount];
						$googlemaps->addPolylinePoint($pl,$pt["LAT"],$pt["LON"]);
					}	
					if ($trkptcount < $trkptmax - 1) {
						$trkptcount = $trkptmax - 1;
						$pt = $gpxdata["trk".$trkcount]["trkpt".$trkptcount];
						$googlemaps->addPolylinePoint($pl,$pt["LAT"],$pt["LON"]);
					}				
				}
			}
			if ($manualzoom == 4) {
				$googlemaps->clearCenterCoords();
				$googlemaps->adjustCenterCoords($maxlon,$maxlat);
				$googlemaps->adjustCenterCoords($minlon,$maxlon);
			}			
			print($googlemaps->getContentElement());
		} else {
			if (isset($_GET["kmlid"])) {
				$file = getpathresolved($id);
				require_once('kmlParser.php');
				$kmlfile = new kmlParser();
				$kmlfile->parse($file);
				
				$kmldata = $kmlfile->output;
				
				for ($i=0; $i<count($kmldata["coordinates"]); $i++) 
				{
					$googlemaps->adjustCenterCoords($kmldata["coordinates"][$i]["lon"],$kmldata["coordinates"][$i]["lat"]);
				}
				
				if ($manualzoom == 4) {
					$googlemaps->clearCenterCoords();
					$googlemaps->adjustCenterCoords($maxlon,$maxlat);
					$googlemaps->adjustCenterCoords($minlon,$maxlon);
				}
				
				$file = getpath($id);
				print($googlemaps->getKMLContentElementOnly($file));				
			} else {
				if (isset($_GET["mygooglemapid"])) {
					if ($manualzoom == 4) {
						$googlemaps->clearCenterCoords();
						$googlemaps->adjustCenterCoords($maxlon,$maxlat);
						$googlemaps->adjustCenterCoords($minlon,$maxlon);
					}
					
					$file = getpath($id);
					print($googlemaps->getKMLContentElementOnly($file));									
				}
			}
		}
	?>
	</body>
</html>
<?php
	function getpath($id) {
		global $wpdb;
		// Check IP From IP Logging Database
		$ret = $wpdb->get_var("SELECT xml_path FROM $wpdb->xmlgooglemapsdb WHERE xml_id = $id");
		return $ret;	
	}
	
	function getpathresolved($id) {
		global $wpdb;
		// Check IP From IP Logging Database
		$ret = $wpdb->get_var("SELECT xml_path_resolved FROM $wpdb->xmlgooglemapsdb WHERE xml_id = $id");
		return $ret;	
	}
	
	function getvarstring($id) {
		global $wpdb;
		// Check IP From IP Logging Database
		$ret = $wpdb->get_var("SELECT xml_varstring FROM $wpdb->xmlgooglemapsdb WHERE xml_id = $id");
		return $ret;	
	}
	
?>