<?php
/*
Plugin Name: XML Google Maps
Plugin URI: http://www.matusz.ch/
Feed URI: 
Description: Plugin to convert GPX & KML Links to Google Maps.
Version: 0.4 Alpha
Author: Patrick Matusz
Author URI: http://www.matusz.ch/
*/

$wpdb->xmlgooglemapsdb = $table_prefix . 'xmlgooglemaps';

if(!function_exists("stripos")) 
{
  function stripos($str, $needle) 
  {
   return strpos(strtolower($str),strtolower($needle));
  }
}


function xmlgooglemaps_converter($content) {
	global $wpdb;
	dbinstall();	
	//GPX
	preg_match_all('/\<a(.*?)href="([a-zA-Z0-9\/:\-\._]*?.gpx)"(.*?)\>(.*?)\<\/a\>/i', $content, $found);
	for ($i=0; $i< count($found[0]);$i++) {
		$file = $found[2][$i];
		
		$server_url = $_SERVER["HTTP_HOST"];
		$server_path = $_SERVER["DOCUMENT_ROOT"];		
		$index = stripos($file,"://");
		$server_url = substr($file,0,$index+3).$server_url;
		
		$file_resolved = $file;

		if (stripos($file,$server_url)==0) {
			$file_resolved = str_replace($server_url,$server_path,$file);
		}
		
		$urlstring = $found[4][$i];
		$iurlstring = stripos($urlstring,"[");
		$displayurl = $found[0][$i];
		if ($iurlstring !== false) {
			$jurlstring = stripos($urlstring,"]",$iurlstring);
			$iurlstring += 1;
			$varstring = substr($urlstring, $iurlstring, $jurlstring-$iurlstring);

		} else {
			$varstring = "";
		}
		
		if (stripos($varstring,"urldisplaymode=none")!==false) {
			$displayurl = "";
		} else {
			if (stripos($varstring,"urldisplaymode=showvars")===false) {				
				$displayurl = str_replace("[".$varstring."]","",$displayurl);
			}
		}		
		
		$gpxid = getid($file, $file_resolved, $varstring);
		
		$content = str_replace($found[0][$i],'<iframe src="'.get_option('siteurl').'/wp-content/plugins/xml-google-maps/show.php?gpxid='.$gpxid.'" width="100%" height="405" style="border:0px;" name="Google Gpx Maps"></iframe>'.$displayurl,$content);
	}
	
	//KML	
	preg_match_all('/\<a(.*?)href="([a-zA-Z0-9\/:\-\._]*?.kml)"(.*?)\>(.*?)\<\/a\>/i', $content, $found);
		
	for ($i=0; $i< count($found[0]);$i++) {
		$file = $found[2][$i];
		
		$server_url = $_SERVER["HTTP_HOST"];
		$server_path = $_SERVER["DOCUMENT_ROOT"];		
		$index = stripos($file,"://");
		$server_url = substr($file,0,$index+3).$server_url;
		
		$file_resolved = $file;

		if (stripos($file,$server_url)==0) {
			$file_resolved = str_replace($server_url,$server_path,$file);
		}

		$displayurl = $found[0][$i];
		$urlstring = $found[4][$i];
		$iurlstring = stripos($urlstring,"[");
		if ($iurlstring !== false) {
			$jurlstring = stripos($urlstring,"]",$iurlstring);
			$iurlstring += 1;
			$varstring = substr($urlstring, $iurlstring, $jurlstring-$iurlstring);
		} else {
			$varstring = "";
		}
		
		if (stripos($varstring,"urldisplaymode=none")!==false) {
			$displayurl = "";
		} else {
			if (stripos($varstring,"urldisplaymode=showvars")===false) {
				$displayurl = str_replace("[".$varstring."]","",$displayurl);
			}
		}
		
		$kmlid = getid($file, $file_resolved, $varstring);
		
		$content = str_replace($found[0][$i],'<iframe src="'.get_option('siteurl').'/wp-content/plugins/xml-google-maps/show.php?kmlid='.$kmlid.'" width="100%" height="405" style="border:0px;" name="Google KML Maps"></iframe>'.$displayurl,$content);
	}
	
	// Google Maps Meine Karten: http://maps.google.com/maps/ms?ie=UTF8&hl=de&msa=0&output=nl&msid=102758581694521177745.00000111d56d20b14f816
	
	preg_match_all('/\<a(.*?)href="(http:\/\/maps\.google\.com\/maps\/ms[a-zA-Z0-9\/:\-\._?&=;]*?)"(.*?)\>(.*?)\<\/a\>/i', $content, $found);

	for ($i=0; $i< count($found[0]);$i++) {
		$file = $found[2][$i];
		$file_resolved = $file;
		
		$displayurl = $found[0][$i];
		$urlstring = $found[4][$i];
		
		$iurlstring = stripos($urlstring,"[");
		if ($iurlstring !== false) {
			$jurlstring = stripos($urlstring,"]",$iurlstring);
			$iurlstring += 1;
			$varstring = substr($urlstring, $iurlstring, $jurlstring-$iurlstring);
		} else {
			$varstring = "";
		}
		
		if (stripos($varstring,"urldisplaymode=none")!==false) {
			$displayurl = "";
		} else {
			if (stripos($varstring,"urldisplaymode=showvars")===false) {
				$displayurl = str_replace("[".$varstring."]","",$displayurl);
			}
		}
		
		$mygooglemapid = getid($file, $file_resolved, $varstring);
		
		$content = str_replace($found[0][$i],'<iframe src="'.get_option('siteurl').'/wp-content/plugins/xml-google-maps/show.php?mygooglemapid='.$mygooglemapid.'" width="100%" height="405" style="border:0px;" name="Google My Map"></iframe>'.$displayurl,$content);
	}
	
	
	return $content;	
}

add_filter('the_content', 'xmlgooglemaps_converter', 2);

function dbinstall() {
	global $wpdb;
	include_once(ABSPATH.'/wp-admin/upgrade-functions.php');
	// Create Post Ratings Table
	$create_sql = "CREATE TABLE $wpdb->xmlgooglemapsdb (".
			"xml_id INT(11) NOT NULL auto_increment,".
			"xml_path TEXT NOT NULL ,".
			"xml_path_resolved TEXT NOT NULL ,".
			"PRIMARY KEY (xml_id))";
	maybe_create_table($wpdb->xmlgooglemapsdb, $create_sql);
	maybe_add_column($wpdb->xmlgooglemapsdb,"xml_varstring","ALTER TABLE $wpdb->xmlgooglemapsdb ADD COLUMN xml_varstring TEXT NOT NULL;");
}

function getid($path, $resolvedpath, $varstring) {
	global $wpdb;
	// Check IP From IP Logging Database
	$ret = $wpdb->get_var("SELECT xml_id FROM $wpdb->xmlgooglemapsdb WHERE xml_path = '$path' AND xml_path_resolved = '$resolvedpath' AND xml_varstring = '$varstring'");
	if ($ret == 0) {
		$wpdb->query("INSERT INTO $wpdb->xmlgooglemapsdb (xml_path, xml_path_resolved, xml_varstring) VALUES ('$path','$resolvedpath','$varstring')");
		$ret = getid($path, $resolvedpath, $varstring);
	}
	return intval($ret);	
}
?>